/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest{}

// AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest struct for AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest
type AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest struct {
	Service *string                      `json:"service,omitempty"`
	Data    *FacebookStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest instantiates a new AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest() *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest {
	this := AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest{}
	var service string = "facebook_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest {
	this := AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest{}
	var service string = "facebook_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) GetData() FacebookStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret FacebookStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) GetDataOk() (*FacebookStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given FacebookStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) SetData(v FacebookStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest struct {
	value *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) Get() *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) Set(val *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest(val *AppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) *NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerFacebookStaticFacebookStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
